import org.codehaus.gant.GantBinding

/*
 * Hooks an event handler to the CompileStart event to run the Hml to Gsp generator
 */

Ant.property(environment: "env")

/**
 * Hooks to the compile grails event
 */
eventCompileEnd = {GantBinding compileBinding ->
  if (compilingHBuilderPlugin( basedir)) {
    return
  }
  def pluginDir = "${getPluginDirForName('hbuilder').path}"
  def offset = pluginDir.indexOf( "plugins")
  def pluginClassesDir = pluginDir.substring( 0, offset) + "plugin-classes"
  
  ant.taskdef(name: 'hbuilderc', classname: 'com.blogspot.unobfuscated.HmlCompileTask', classpath: pluginClassesDir)
  
  try {
    ant.hbuilderc( basedir:new File( basedir))
  } catch (Exception e) {
    Ant.fail(message: "Could not compile Hml sources: " + e.message)
  }
}

/**
 * Detects whether we're compiling the hbuilder plugin itself
 */
private boolean compilingHBuilderPlugin( basedir) { 
    //println "getPluginDirForName('hbuilder'): ${getPluginDirForName('hbuilder').path}"
    //println "${getPluginDirForName("hbuilder").path}"
    //println "${basedir}"
    return ("${getPluginDirForName("hbuilder").path}" == "${basedir}")
}