/*
 * Copyright (C) 2011-2012 @unobfuscator All Rights Reserved.
 *
 * Open source licensed under the MIT license
 * 
 */

package com.blogspot.unobfuscated;

import java.io.IOException;

import groovy.util.HBuilder;

/*
 * Generate GSP pages for a single file or a whole directory of files
 */

public class HmlGroovyPageResourceLoader {

    public static compile( File path) {
        if (path.exists()) {
            try {
                // test whether the file is a directory or a normal file
                def fs = [path]
                def pList = []
                def f
                while( fs.size() > 0) {
                    f = fs[0]
                    fs.remove( f)
                    if ( f.isDirectory()) {
                        fs.addAll( ((Collection)f.listFiles()))
                    } else if ( f.isFile()){
                        pList.add( f)
                    }
                }
                while( pList.size() > 0) {
                    f = pList[0]
                    pList.remove( f)
                    if ( !f.path.endsWith( ".hml")) continue;
                    def buf = new StringBuffer();
                    char[] cbuf
                    cbuf = new char[1024];
                    java.io.Reader ins = new java.io.InputStreamReader(new FileInputStream( f));
                    try {
                        int charsRead
                        charsRead = ins.read(cbuf);
                        while (charsRead >= 0) {
                            buf.append(cbuf, 0, charsRead);
                            charsRead = ins.read(cbuf);
                        }
                        def fileOutput = """
<%@ page import="groovy.util.HBuilder" %>
<%
hb = new HBuilder();
hb.with {
${buf.toString()}
}
%>
<%= hb.getOutput()%>
"""
                        def oPath = f.path.replaceFirst(".hml\$", ".gsp");
                        def fWriter = new FileWriter( oPath);
                        char[] buffer = new char[fileOutput.length()]; 
                        fileOutput.getChars(0, fileOutput.length(), buffer, 0); 
                        fWriter.write( buffer);
                        fWriter.close();
                    } catch (java.io.IOException e) {
                        System.err.println("Error processing file: " + e.getMessage());
                    }
                    try {
                        ins.close();
                    } catch (java.io.IOException e) {
                        System.err.println("Error processing file: " + e.getMessage());
                    }
                }
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
    }
}
